/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.recallEstimation;

import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.SortedMap;
import org.apache.commons.math4.distribution.AbstractRealDistribution;
import org.apache.commons.math4.distribution.LogNormalDistribution;
import sf.recallEstimation.UnivariateFunctionImpl.ProbabilitySketchBitDiffers;
import sf.recallEstimation.originalDistanceDistributionApprox.LognormalParamEstimator;
import sf.recallEstimation.pxEvaluator.PxEvaluator;

/**
 *
 * @author xmic
 */
public class TestRecallEstimator {

    public static void main(String[] args) throws FileNotFoundException {
        // Original distance distribution to function
        // mpeg7 cophir
//        double maxDistance = 6;
//        String csvPathOrigDistanceDistribution = "c:\\Data\\2016\\2016_Recall\\Cophir_MPEG7\\Distance_distribution\\distance-distribution-sapir2-agg.csv";
//        String csvPathProbBitsDiffer = "c:\\Data\\2016\\2016_Recall\\Cophir_MPEG7\\Probabilities_that_bit_differs\\res_256b_100K_objects_average_hladke.csv";
//        int[] lengths = new int[]{32, 48, 64, 160, 256};
//        double[] iDims = new double[]{10.89d, 12.80d, 14.53d, 16.73d, 16.53d};
        // decaf profiset
        double maxDistance = 206;
        String csvPathOrigDistanceDistribution = "c:\\Data\\2016\\2016_Recall\\Profiset_Decaf\\Distance_distribution\\l2.csv";
        String csvPathProbBitsDiffer = "c:\\Data\\2016\\2016_Recall\\Profiset_Decaf\\Probabilities_that_bit_differs\\";
        double[] iDims = new double[]{12.20d, 17.53d, 26.07d, 28.99d, 29.37d, 21.85d};
        int[] lengths = new int[]{32, 64, 128, 205, 256};
//
        LognormalParamEstimator paramEstimator = new LognormalParamEstimator(csvPathOrigDistanceDistribution);
        double[] muSigma = paramEstimator.estimateMuSigma();
        AbstractRealDistribution f = new LogNormalDistribution(muSigma[0], muSigma[1]);
//        float x = 0; // toto je normalizovane, narozdil od empirickych testu
//        float stepDistance = 1;
//        while (x < maxDistance) {
//            System.out.println(f.value(x) + ";" + x);
//            x += stepDistance;
//            x = Tools.round(x, stepDistance, false);
//        }
//        System.exit(0);
        // Probability that bits differ to Function
        // Recall estimator instance
        int k = 10;
        int[] candSetSizes = new int[]{100, 500, 1000, 1750, 2500, 3500, 5000, 7500, 10000, 12500, 15000, 20000, 25000, 30000, 40000, 50000, 62500, 75000, 100000, 125000, 150000};

//        lengths = new int[]{32, 64};
//        iDims = new double[]{17.53d};
//        candSetSizes = new int[]{3500};
//        LogManager.getLogManager().reset();
//        Logger.getLogger(java.util.logging.Logger.GLOBAL_LOGGER_NAME).setLevel(java.util.logging.Level.WARNING);
//
        System.setOut(new PrintStream("c:\\Data\\2016\\2016_Recall\\Vysledky_DECAF_10NN_mub_sigma_eval.csv"));
        System.setErr(new PrintStream("c:\\Data\\2016\\2016_Recall\\Vysledky_DECAF_10NN_mub_sigma_eval_err.csv"));
        System.out.println("Candidate set size;bit count;recall");
        for (int i = 0; i < lengths.length; i++) {
            int length = lengths[i];
            SortedMap<Float, Float> plotXY = PxEvaluator.parse(csvPathProbBitsDiffer + "res_" + length + "b_10K_objects_with_mu_sigma.csv");
            ProbabilitySketchBitDiffers pxProbabilitySketchBitsDiffer = new ProbabilitySketchBitDiffers(plotXY);
            Double sketchesIDim = iDims[i];
            RecallEstimator recallEstimator = new RecallEstimator(1000000, k, maxDistance, sketchesIDim, length, f, pxProbabilitySketchBitsDiffer, PxEvaluator.getMub(), PxEvaluator.getSigmab(), true);
            for (int candSetSize : candSetSizes) {
                double recall = recallEstimator.estimateRecall(candSetSize) * 100;
                System.out.println(candSetSize + ";" + length + ";" + recall);
            }
            System.out.println();
        }
    }
}
