/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.recallEstimation.UnivariateFunctionImpl;

import java.util.concurrent.Semaphore;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.apache.commons.math4.analysis.integration.BaseAbstractUnivariateIntegrator;
import org.apache.commons.math4.distribution.NormalDistribution;
import sf.recallEstimation.integrating.OnePeakPositiveNormalizedFunctionIntegrator;

/**
 *
 * @author xmic
 */
public class PrRankXLessMThread implements Runnable {

    private final double mub;
    private final double sigmab;
    private final int mCandidateSetSize;
    private final AtomicInteger counter;
    private final int counterMax;
    private Double result = null;
    private final Semaphore sem;

    public PrRankXLessMThread(AtomicInteger counter, int counterMax, double mub, double sigmab, int mCandidateSetSize, Semaphore sem) {
        this.counter = counter;
        this.mub = mub;
        this.sigmab = sigmab;
        this.mCandidateSetSize = mCandidateSetSize;
        this.sem = sem;
        this.counterMax = counterMax;
    }

    public Double getResult() {
        return result;
    }

    public void setResult(Double result) {
        this.result = result;
    }

    @Override
    public void run() {
        result = evaluateIntegral(mub, sigmab);
        counter.incrementAndGet();
        if (sem != null) {
            sem.release();
        }
        Logger.getLogger(PrRankXLessMThread.class.getName()).log(Level.INFO, "Integral for {0} bits out of {1} evaluated. Result: {2}", new Object[]{counter, counterMax, result});
    }

    private double evaluateIntegral(double mub, double sigmab) {
        BaseAbstractUnivariateIntegrator integrator = new OnePeakPositiveNormalizedFunctionIntegrator(mub);
        if(sigmab == 0){
            return 0;
        }
        NormalDistribution fYMuBSigmaB = new NormalDistribution(mub, sigmab);
        // miuns nekonecno
        double lowerBound = -20 * mub;
        return integrator.integrate(Integer.MAX_VALUE, fYMuBSigmaB, lowerBound, mCandidateSetSize);
    }

}
