/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.recallEstimation.UnivariateFunctionImpl;

import java.awt.geom.Point2D;
import java.util.Map;
import java.util.SortedMap;
import org.apache.commons.math4.analysis.UnivariateFunction;

/**
 *
 * @author xmic
 */
public class ProbabilitySketchBitDiffers implements UnivariateFunction {

    private final SortedMap<Float, Float> plotXY;

    public ProbabilitySketchBitDiffers(SortedMap<Float, Float> plotXY) {
        this.plotXY = plotXY;
    }

    @Override
    public double value(double x) {
        Point2D.Double segmentStart = null;
        Point2D.Double segmentEnd = null;
        int i = 0;
        Map.Entry<Float, Float> prevPoint = null;
        for (Map.Entry<Float, Float> point : plotXY.entrySet()) {
            if (i != 0) {
                if (prevPoint.getKey() <= x && point.getKey() >= x) {
                    segmentStart = new Point2D.Double(prevPoint.getKey(), prevPoint.getValue());
                    segmentEnd = new Point2D.Double(point.getKey(), point.getValue());
                    break;
                }
            }
            prevPoint = point;
            i++;
        }
        if (segmentEnd == null) {
            return 1f;
        }
        double directive = makeDirective(segmentStart.y, segmentEnd.y, segmentStart.x, segmentEnd.x);
        return segmentStart.y + directive * (x - segmentStart.x);
    }

    private double makeDirective(double y1, double y2, double x1, double x2) {
        return (y1 - y2) / (x1 - x2);
    }

}
