/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.recallEstimation.UnivariateFunctionImpl;

import org.apache.commons.math4.analysis.UnivariateFunction;

/**
 *
 * @author xmic
 */
public class Pxb implements UnivariateFunction {

    private final int bSkLength;
    private final int bBitIndex;
    private final UnivariateFunction pxProbSkBitsDif;
    private final Double sketchesIDim;

    public Pxb(int bSkLength, int bBitIndex, Double sketchesIDim, UnivariateFunction pxProbSkBitsDif) {
        this.bSkLength = bSkLength;
        this.bBitIndex = bBitIndex;
        this.pxProbSkBitsDif = pxProbSkBitsDif;
        this.sketchesIDim = sketchesIDim;
    }

    @Override
    public double value(double x) {
        double pxProbSkBitsDifX = pxProbSkBitsDif.value(x);
        int limitForSubtract = (int) Math.round(pxProbSkBitsDifX * bSkLength);
        PxbSmallBinAnalogue pxb = new PxbSmallBinAnalogue(bSkLength, sketchesIDim, pxProbSkBitsDifX);
        double sumA = 0;
        if (bBitIndex <= limitForSubtract) {
            for (int i = 0; i < bBitIndex; i++) {
                sumA += pxb.value(i);
            }
        } else {
            sumA = 1;
            for (int i = bSkLength; i >= bBitIndex; i--) {
                sumA -= pxb.value(i);
            }
        }
        double sumB = 1 / 2d * pxb.value(bBitIndex);
        return Math.max(0, Math.min(sumA + sumB, 1));
    }

}
