/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.recallEstimation.UnivariateFunctionImpl;

import java.util.concurrent.Semaphore;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.apache.commons.math4.analysis.UnivariateFunction;

/**
 *
 * @author xmic
 */
public class Sigma2BThread extends Sigma2B implements Runnable {

    private final int bBitIndex;
    private double result;
    private final Semaphore sem;
    private final AtomicInteger counter;
    private final int counterMax;

    public Sigma2BThread(AtomicInteger counter, int counterMax, int nDatasetSize, int bBitIndex, int bSketchLength, double maxDistance, Double sketchesIDim, UnivariateFunction fxDistDistr, UnivariateFunction pxProbSkBitsDif, Semaphore sem) {
        super(nDatasetSize, bSketchLength, maxDistance, sketchesIDim, fxDistDistr, pxProbSkBitsDif);
        this.bBitIndex = bBitIndex;
        this.sem = sem;
        this.counter = counter;
        this.counterMax = counterMax;
    }

    public double getResult() {
        return result;
    }

    @Override
    public void run() {
        result = evaluateSigma2B(bBitIndex);
        counter.incrementAndGet();
        Logger.getLogger(Sigma2BThread.class.getName()).log(Level.INFO, "Variance for {0} bits out of {1} evaluated. Result: {2}", new Object[]{counter, counterMax, Double.toString(result)});
        sem.release();
    }

}
