/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.recallEstimation.originalDistanceDistributionApprox;

import org.apache.commons.math4.analysis.UnivariateFunction;
import org.apache.commons.math4.distribution.LogNormalDistribution;
import org.apache.commons.math4.exception.NotStrictlyPositiveException;

/**
 *
 * @author xmic
 */
public class LogNormalDistributionWithNormalization implements UnivariateFunction {

    private final LogNormalDistribution logNormalDistr;
    private final double normConstant;

    public LogNormalDistributionWithNormalization(double scale, double shape, double min, double max, double stepDistance) throws NotStrictlyPositiveException {
        logNormalDistr = new LogNormalDistribution(scale, shape);
        normConstant = initNormConstant(min, max, stepDistance);
    }

    private double initNormConstant(double min, double max, double step) {
        double sum = 0;
        double cur = min;
        while (cur < max) {
            sum += logNormalDistr.density(cur);
            cur += step;
        }
        return 1 / sum;
    }

    @Override
    public double value(double x) {
        double ret = logNormalDistr.density(x);
        return ret;
    }

}
