/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.separability;

import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import main.tools.Tools;
import messif.objects.LocalAbstractObject;
import messif.objects.impl.ObjectFloatVectorL2;
import sf.recallEstimation.pxEvaluator.PxEvaluatorOnCreatedSketches;
import sf.separability.measuredGeneral.QualityOfSketchingTechGenlMeas;
import sf.separabilityMeasured.QualityOfSketchingTechniqueMeasured;

/**
 *
 * @author xmic
 */
public class EstimateQualityOfSketchingTechnique {

    public static void main(String[] args) throws FileNotFoundException {
        int numberOfObjectsToUse = 5000;

        String className = ObjectFloatVectorL2.class.getName();
//        String dataFile = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\profi-neuralnet-1M.data.gz";
        String dataFile = "c:\\Data\\2017\\2017_Separability\\Experiments\\SIFT\\data\\sift-1M.data";
//        float maxDistance = 119;
        float maxDistance = 700;
//        double maxX1 = 62;
//        double maxX1 = 280;
        double maxX1 = 280;
//        double maxX1 = -1;
        // adbis: countOfIntervals decaf: 60, sift 117
//        int distInterval = 2;
        int countOfIntervals = 500;

        List<LocalAbstractObject> data = Tools.getObjects(className, dataFile, numberOfObjectsToUse);
        Map<String[], Float> distsOnData = PxEvaluatorOnCreatedSketches.evaluateDistances(data);
        data = null;

//        String sketches = "c:\\Data\\2017\\2017_Separability\\Experiments\\Decaf\\Sketches\\GHP_50_50_128b.data";
//        evaluateAndPrint(distances, sketches, 128, null, maxDistance, distInterval, numberOfObjectsToUse, balanceOfBits);
        String preffix = "c:\\Data\\2017\\2017_Separability\\Experiments\\SIFT\\Sketches\\"; // prepsat
        List<Object[]> sketchesFilesNamesWithLengths = addFiles();
//
        int objCount = 50;; //50
        QualityOfSketchingTechniqueMeasured.MIN_NUMBER_OF_DISTANCES = objCount;
        Iterator<Object[]> it = sketchesFilesNamesWithLengths.iterator();
        String output = "c:\\Data\\2017\\2017_Separability\\Experiments\\SIFT\\PMGeneral\\Try2.csv";
//        String output = null;
        if (output != null) {
            System.setOut(new PrintStream(output));
        }
        float stepSize = QualityOfSketchingTechnique.getStepSize(maxDistance, countOfIntervals);
        Map<Integer, Double> distanceXDensity = QualityOfSketchingTechGenlMeas.evaluateDensityOfDistX(distsOnData, countOfIntervals, stepSize);

        while (it.hasNext()) {
            System.gc();
            Object[] next = it.next();
            String sketchesPath = preffix + next[0] + ".data";
            System.out.print(sketchesPath + ";");
            Logger.getLogger(EstimateQualityOfSketchingTechnique.class.getName()).log(Level.INFO, "Processing sketches from file {0}", sketchesPath);
            System.gc();
            Integer sketchLength = Integer.parseInt((String) next[1]);
            float balanceOfBits = (float) next[2];

            QualityOfSketchingTechGenlMeas evaluator = new QualityOfSketchingTechGenlMeas(distanceXDensity, distsOnData, sketchesPath, sketchLength, output, maxX1, countOfIntervals, stepSize);
            evaluator.evaluateAndPrint(output, maxX1, stepSize);
//            QualityOfSketchingTechniqueAnalytiqueImpl.evaluateAndPrint(distsOnData, sketchesPath, sketchLength, output, maxDistance, maxX1, distInterval, numberOfObjectsToUse, balanceOfBits);
//            QualityOfSketchingTechniqueMeasured.evaluateAndPrint(distsOnData, sketchesPath, output, maxDistance, maxX1, distInterval);
        }
//        }

    }

//    private static void evaluateAndPrint(Map<String[], Float> distsOnData, String sketchesPath, Integer sketchLength, String output, double maxDistance, int distInterval, int numberOfObjectsToUse, float balanceOfBits) throws FileNotFoundException {
//        QualityOfSketchingTechniqueAnalytiqueImpl.evaluateAndPrint(distsOnData, sketchesPath, sketchLength, output, maxDistance, -1, distInterval, numberOfObjectsToUse, balanceOfBits);
//    }
    private static List<Object[]> addFiles() {
        List<Object[]> ret = new ArrayList<>();
        String[] lengths = new String[]{"064", "128", "192", "256"};
        lengths = new String[]{"064", "256"};
        for (String length : lengths) {
            ret.add(new Object[]{"BP_50_" + length, length, 0.5f});
            ret.add(new Object[]{"GHP_50_" + length, length, 0.5f});
//            ret.add(new Object[]{"GHP_80_" + length, length, 0.8f});
        }
        lengths = new String[]{"064", "128"};
        lengths = new String[]{"064"};
        for (String length : lengths) {
            ret.add(new Object[]{"THRR_50_" + length, length, 0.5f});
//            ret.add(new Object[]{"NSP_50_" + length, length, 0.5f});
        }
//        lengths = new String[]{"064"};
//        for (String length : lengths) {
//            ret.add(new Object[]{"THRR_50_" + length, length, 0.5f});
//        }
//        lengths = new String[]{"128"};
//        for (String length : lengths) {
//            ret.add(new Object[]{"GHP_50_" + length, length, 0.5f});
//        }
//        lengths = new String[]{"256"};
//        for (String length : lengths) {
//            ret.add(new Object[]{"GHP_80_" + length, length, 0.8f});
//        }
//        lengths = new String[]{"128"};
//        for (String length : lengths) {
//            ret.add(new Object[]{"THRR_50_" + length, length, 0.5f});
//        }
//        lengths = new String[]{"256"};
//        for (String length : lengths) {
//            ret.add(new Object[]{"GHP_50_" + length, length, 0.5f});
//        }
        return ret;
    }
}
